"use strict";

   var shifts = {};
   initShiftsMapping();
   
   function initShiftsMapping()
   {
      for (var i = 97; i <= 122; i++)
      {
         shifts[i] = i - 32;
         
      }
      
      //~ 192 - 96 = 192 - 126
      shifts[96] = 126;
      //! 49 - 33
      shifts[49] = 33;
      //@ 50 - 64
      shifts[50] = 64;
      //# 51 - 35
      shifts[51] = 35;
      //$ 52 - 36
      shifts[52] = 36;
      //% 53 - 37
      shifts[53] = 37;
      //^ 54 - 94
      shifts[54] = 94;
      //& 55 - 38
      shifts[55] = 38;
      //* 56 - 42
      shifts[56] = 42;
      //( 57 - 40
      shifts[57] = 40;
      //) 48 - 41
      shifts[48] = 41;
      //_ 173 - 45 = 173 - 95
      shifts[45] = 95;
      //+ 61 - 43
      shifts[61] = 43;
      //| 220-92 = 220 - 124
      shifts[92] = 124;
      // [ 219 - 91 = 219 - 123
      shifts[91] = 123;
      // ] 221 - 93 = 221 - 125
      shifts[93] = 125;
      // ; 59 - 58
      shifts[59] = 58;
      // ' 222 - 39 = 222 - 34
      shifts[39] = 34;
      // , 188 - 44 = 188 - 60
      shifts[44] = 60;
      // . 190 - 46 = 190 - 62
      shifts[46] = 62;
      // / 191 - 47 = 191 - 63
      shifts[47] = 63;
   }
   
   function simulateKeyPress(elementId, code, ctrlKey, altKey, shiftKey, metaKey) {
      simulateKeyPressExt(elementId, code, code, ctrlKey, altKey, shiftKey, metaKey);
   }

   function simulateKeyPressExt(elementId, keyDown, keyPress, ctrlKey, altKey, shiftKey, metaKey) {
      var ch;
      try
      {
         ch = String.fromCodePoint(keyPress);
      }
      catch (ex)
      {
         ch = "";
      }

      var input = document.getElementById(elementId);

      if (ctrlKey)
      {
         input.dispatchEvent(createKeyDownUpEvent(true, 17, ctrlKey, altKey, shiftKey, metaKey));
      }
      if (altKey)
      {
         input.dispatchEvent(createKeyDownUpEvent(true, 18, ctrlKey, altKey, shiftKey, metaKey));
      }
      if (shiftKey)
      {
         input.dispatchEvent(createKeyDownUpEvent(true, 16, ctrlKey, altKey, shiftKey, metaKey));
      }
      var keyDownEvent = createKeyDownUpEvent(true, keyDown, ctrlKey, altKey, shiftKey, metaKey);
      input.dispatchEvent(keyDownEvent);
      if (keyDownEvent.defaultPrevented)
      {
         return;
      }
      if (ch !== "") {
         input.dispatchEvent(createKeyPressEvent(ch.charCodeAt(0), ctrlKey, altKey, shiftKey, metaKey));
      }
      input.dispatchEvent(createKeyDownUpEvent(false, keyDown, ctrlKey, altKey, shiftKey, metaKey));
      
      if (ctrlKey)
      {
         input.dispatchEvent(createKeyDownUpEvent(false, 17, false, altKey, shiftKey, metaKey));
      }
      if (altKey)
      {
         input.dispatchEvent(createKeyDownUpEvent(false, 18, false, false, shiftKey, metaKey));
      }
      if (shiftKey)
      {
         input.dispatchEvent(createKeyDownUpEvent(false, 16, false, false, false, metaKey));
      }

   }

   function createKeyDownUpEvent(down, keyDown, ctrlKey, altKey, shiftKey, metaKey)
   {
      var event = document.createEvent("KeyEvents");
      
      event.initKeyEvent(down ? "keydown" : "keyup", false, true, null, ctrlKey,
            altKey, shiftKey, metaKey, keyDown, 0);
      return event;
   }
   
   function createKeyPressEvent(keyPress, ctrlKey, altKey, shiftKey, metaKey)
   {
      var event = document.createEvent("KeyEvents");
      var charCode;
      if (shiftKey)
      {
         charCode = shifts[keyPress];
      }
      if (charCode === undefined)
      {
         charCode = keyPress;
      }
      event.initKeyEvent("keypress", false, true, null, ctrlKey,
            altKey, shiftKey, metaKey, charCode > 31 ? 0 : charCode,
                  charCode > 31 ? charCode : 0);
      return event;
   }
